from types import NoneType
import torch
import torch.nn as nn


class FFModel():
    def __init__(self, hdim, lrate, device):
	""" hdim -- hidden layer size
	    lrate -- learning rate
	"""
        self.lrate = lrate
        # hidden layer
        self.w1 = torch.empty([2, hdim], dtype=torch.float, device=device).uniform_(-1.0, 1.0)
        self.w1.requires_grad_()
	# ...

    
    def forward(self, x):
        """ Compute scores for inputs x 
	 x : [N x d]
	"""
        
        scores = None

        return scores

    def log_lik(self, scores, targets):
        """
        Compute averaged (conditional) log-likelihood for given data 
        """

        ll = None

        return ll

    def zero_grad(self):
        # set .grad to None (or zeroes) for all parameters
	raise NotImplementedError()

    def gradient(self, x, targ):
        """
        automatic differentiation: compute gradient w.r.t. to network parameters;
        gradients are stored in tensor attributes, e.g. self.w1.grad
        """
        self.zero_grad()
        scores = self.forward(x)
        ll = self.log_lik(scores, targ)
        # automatic differentiation, very simple!
        ll.backward()

        return ll.detach().item()


    def grad_step(self, x, targ):
        """ Learning step """
        # compute gradients
        ll = self.gradient(x, targ)
        # apply gradient step: update all parameters
	raise NotImplementedError()
        return ll
    
    def check_gradient(self, x, targ, pname):
        p = getattr(self, pname)
        epsilon = 1.e-5
        # compute gradients
        ll = self.gradient(x, targ)
        # check 
	raise NotImplementedError()

        print("# Grad error in {}: {:.4}".format(pname, torch.abs(dummy)))



